/**
 * YouRoller - mootools 1.2 slider
 * @version		2.0.3
 * @MooTools version 1.2,1.3,1.4
 * @author		Constantin Boiangiu <info [at] constantinb.com>
 * @Copyright Youjoomla.com
 */
var YouRoller = new Class({
	
	Implements: [Options],
	
	options: {		
		container: null,
		slideClass: 'slide',
		nextBtnContainer: 'buttons',
		nextBtnClass: 'next', 
		nextBtnText: 'forward',
		bounceDist: 30,
		bounceTime: 500,
		outside:2000, // how far outside is the slider going; it's good for different screen widths
		autoslide: null
	},
	
	initialize: function(options) {
		this.setOptions(options||null);		
		if(!$(this.options.container)) return;		
		this.container = $(this.options.container);
		this.currentSlide = 0;
		this.childrenFX = new Array();
		this.start();		
	},
	
	start: function(){
		this.slides = this.container.getElements('.'+this.options.slideClass);		
		this.nextLink = new Element('a',{
			'class':this.options.nextBtnClass,
			'href':'#',
			'text':this.options.nextBtnText
		});
		/* add event on click next */
		this.nextLink.addEvent('click', this.nextSlide.bind(this));
		
		this.slides.each(function(slide, i){
			slide.addEvents({
				'mouseenter': function(){
					this.stopAuto();
				}.bind(this),
				'mouseleave': function(){
					this.startAuto();
				}.bind(this)
			}).setStyle('position', 'absolute');
			
			this.slides[i]['fx'] = new Fx.Morph(slide, {duration:400, wait:false, transition:Fx.Transitions.Sine.easeInOut});
			if( i !== this.currentSlide ){
				slide.setStyle('left',this.options.outside);
			}
			/* get all the elements inside the slide */
			var children = slide.getChildren();
			/* set fx on kids */
			var fx = new Array();
			children.each(function(kid, current){
				var elem = new Hash();
				elem.fx = new Fx.Morph(kid, {duration:this.options.bounceTime, wait:false, transition:Fx.Transitions.Sine.easeInOut});
				elem.left = kid.getStyle('left').toInt();
				elem.toLeft = elem.left + this.options.bounceDist*( current + (current == children.length-1 ? 2 : 0.5) );
				fx[current] = elem;				
			}.bind(this));
			
			this.childrenFX[i] = fx;
			this.slides[i]['kids'] = children;
			/* inject next link into current slide */
			this.injectNext();
		}.bind(this));
		
		this.startAuto();
		
	},
	
	startAuto: function(){
		if( !this.options.autoslide ) return;
		this.period = this.gotoNext.periodical(this.options.autoslide, this);
	},
	
	stopAuto: function(){
		clearTimeout(this.period);
	},
	
	resumeAuto: function(){
		if( !this.options.autoslide ) return;
		clearTimeout(this.period);
		this.period = this.gotoNext.periodical(this.options.autoslide, this);
	},
	
	gotoNext: function(){		
		this.nextLink.fireEvent('click');		
	},
	
	injectNext: function(){
		this.nextLink.inject(this.slides[this.currentSlide].getElement('.'+this.options.nextBtnContainer));	
	},
	
	nextSlide: function(event){
		if(event)
		event.stop();		
		this.childrenFX[this.currentSlide].each(function(eff, i){
			eff.fx.start({'left':[eff.left, eff.toLeft]});
		}.bind(this));
		this.moveSlide.bind(this).delay(this.options.bounceTime);
	},
	
	moveSlide: function(){
		this.slides[this.currentSlide]['fx'].start({'left':-this.options.outside}).chain(this.resetSlide.bind(this));		
	},
	
	resetSlide: function(){
		this.slides[this.currentSlide].setStyle('left',this.options.outside);
		
		this.slides[this.currentSlide].kids.each(function(el, i){
			el.setStyle('left', this.childrenFX[this.currentSlide][i].left);													  
		}.bind(this));
		
		this.currentSlide = this.currentSlide < this.slides.length-1 ?  this.currentSlide+1 : 0;
		this.injectNext();
		this.bringSlide();
		this.resumeAuto();
	},
	
	bringSlide: function(){
		this.slides[this.currentSlide]['fx'].start({'left':0});
	}
});